; electricity logo
;  
; --------------------------------------------------------------------------------------------------------------
; version 1.0 by Michael Schalla 2003/02/17
; version 2.0 by Eric Lamarque 2004/08/20
; Version 3.0 by LightningIsMyName (LIMN) and saulgoode from www.GIMPtalk.com 2007/11/18   a modifacation to work on GIMP 2.4
; Version 3.1 by LightningIsMyName (LIMN) - Adding an animation function
; --------------------------------------------------------------------------------------------------------------
;

;Duplicate Layer - new for the animated version

(define (script-fu-duplicate-layer-electricity-anim img layer1)

     (let* (

	    (duplicate) (position)
     )
	

	;undo group
	(gimp-image-undo-group-start img)

	(set! position (car(gimp-image-get-layer-position img layer1)))
	(set! position (- position 1))

	(set! duplicate (car(gimp-layer-new-from-drawable layer1 img)))
	(gimp-image-add-layer img duplicate -1)

	;end of undo group
	(gimp-image-undo-group-end img)

	;Refresh View
	(gimp-displays-flush)

))


;from the original script
(define (apply-electricity-logo-effects img inLayer inGrow inElectricity inColor)
     (let*
          (
               (width (car (gimp-drawable-width inLayer)))
               (height (car (gimp-drawable-height inLayer)))

               (theElectricityLayer (car (gimp-layer-new img width height RGBA-IMAGE "Electricity" 100 ADDITION)))

               (old-fg (car (gimp-palette-get-foreground)))
               (old-bg (car (gimp-palette-get-background)))
               (splineValue (cons-array 10 'byte))
               (splineArr (cons-array 6 'byte))
               (red (min 254 (max 1 (car inColor))))
               (green (min 254 (max 1 (cadr inColor))))
               (blue (min 254 (max 1 (caddr inColor))))
               (gray (/ (+ (* red 299) (* green 587) (* blue 114)) 1000))
          )
     
          (gimp-image-resize img width height 0 0)
          (gimp-image-add-layer img theElectricityLayer 0)
          (gimp-edit-clear theElectricityLayer)

          (gimp-selection-layer-alpha inLayer)

          (if (> inGrow 0)
               (gimp-selection-grow img inGrow)
               (if (< inGrow 0)
                    (gimp-selection-shrink img (- 0 inGrow))
               )     
          )
               
          (gimp-palette-set-foreground '(255 255 255))
          (gimp-edit-fill theElectricityLayer FG-IMAGE-FILL)
          (gimp-selection-none img)

          (plug-in-cubism 1 img theElectricityLayer inElectricity 2.5 0)
          (plug-in-ripple 1 img theElectricityLayer inElectricity (/ inElectricity 4) 1 0 1 TRUE FALSE)
          (plug-in-ripple 1 img theElectricityLayer inElectricity (/ inElectricity 2) 0 0 1 TRUE FALSE)
          (plug-in-ripple 1 img theElectricityLayer inElectricity (/ inElectricity 4) 1 0 1 TRUE FALSE)
          (plug-in-spread 1 img theElectricityLayer inElectricity inElectricity)

          (plug-in-gauss-iir 1 img theElectricityLayer 3 TRUE TRUE)

          ;; splineValue = #( 0 0 32 64 96 255 160 64 255 0 )
          (aset splineValue 2 32)
          (aset splineValue 3 64)
          (aset splineValue 4 96)
          (aset splineValue 5 255)
          (aset splineValue 6 160)
          (aset splineValue 7 64)
          (aset splineValue 8 255)
          (gimp-curves-spline theElectricityLayer VALUE-LUT 10 splineValue)

          ;; splineRed = #( 0 0 gray red 255 255)
          (aset splineArr 2 gray)
          (aset splineArr 3 red)
          (aset splineArr 4 255)
          (aset splineArr 5 255)
          (gimp-curves-spline theElectricityLayer RED-LUT 6 splineArr)

          ;; splineGreen = #( 0 0 gray green 255 255)
          (aset splineArr 3 green)
          (gimp-curves-spline theElectricityLayer GREEN-LUT 6 splineArr)

          ;; splineBlue = #( 0 0 gray blue 255 255)
          (aset splineArr 3 blue)
          (gimp-curves-spline theElectricityLayer BLUE-LUT 6 splineArr)

          (gimp-curves-spline theElectricityLayer ALPHA-LUT 10 splineValue)

          (gimp-palette-set-background old-bg)
          (gimp-palette-set-foreground old-fg)
     )
)


;from the original script

(define (script-fu-electricity-alphas img theLayer inGrow inElectricity inIceColor)
  (begin
    (gimp-undo-push-group-start img)

		(apply-electricity-logo-effects img theLayer inGrow inElectricity inIceColor)
		
    (gimp-undo-push-group-end img)
    (gimp-displays-flush)))

(script-fu-register "script-fu-electricity-alphas"
	_"<Image>/Filters/Alpha to Logo (MS)/Electricity..."
	"Creates a electricity logo."
	"Michael Schalla"
	"Michael Schalla"
	"Februar 2001"
	"RGBA"
	SF-IMAGE    "Image"						 0
	SF-DRAWABLE "Drawable"				 0
  SF-ADJUSTMENT "Grow"					 '(-6 -50 50 1 1 0 1)
  SF-ADJUSTMENT "Electricity" 	 '(16 2 100 1 1 0 1)
  SF-COLOR  "Electricity Color"  '(32 128 255)
)

;modified source to add the animation option

(define (script-fu-electricity-logos-animated framenum inText inFont inFontSize inIceColor inTextColor inGrow inElectricity inAbsolute inImageWidth inImageHeight inFlatten)
  (let*
    (
      ; Definition unserer lokalen Variablen

      ; Erzeugen des neuen Bildes

      (img  ( car (gimp-image-new 10 10 RGB) ) )
      (theText)
      (theTextWidth)
      (theTextHeight)
      (imgWidth)
      (imgHeight)
      (theBufferX)
      (theBufferY)
      (theTextLayer2)
      (animation)
      (duplicate)
      (framenum_source framenum)
	

      ; Erzeugen einer neuen Ebene zum Bild
      (theLayer (car (gimp-layer-new img 10 10 RGB-IMAGE "Ebene 1" 100 NORMAL) ) )
      (theTextLayer (car (gimp-layer-new img 10 10 RGBA-IMAGE "Ebene 2" 100 NORMAL) ) )

      (old-fg (car (gimp-palette-get-foreground) ) )
      (old-bg (car (gimp-palette-get-background) ) )
      ; Ende unserer lokalen Variablen
    )

    (gimp-image-add-layer  img theLayer 0)
    (gimp-image-add-layer  img theTextLayer 0)

    ; zum Anzeigen des leeren Bildes
    ; (gimp-display-new img)

    (gimp-palette-set-background '(0 0 0) )
    (gimp-palette-set-foreground inTextColor)

    (gimp-selection-all  img)
    (gimp-edit-clear     theLayer)
    (gimp-edit-clear     theTextLayer)
    (gimp-selection-none img)

    (set! theText (car (gimp-text-fontname img theTextLayer 0 0 inText 0 TRUE inFontSize PIXELS inFont)))

    (set! theTextWidth  (car (gimp-drawable-width  theText) ) )
    (set! theTextHeight (car (gimp-drawable-height theText) ) )

    (set! imgWidth inImageWidth )
    (set! imgHeight inImageHeight )

    (if (= inAbsolute FALSE)
      (set! imgWidth (+ theTextWidth theTextHeight inElectricity ) )
    )

    (if (= inAbsolute FALSE)
      (set! imgHeight (+ (* theTextHeight 1.5 ) (*  (+ inElectricity inGrow ) ) ) )
    )

    (set! theBufferX      (/ (- imgWidth theTextWidth) 2) )
    (set! theBufferY      (+ (/ (- imgHeight theTextHeight) 2) (+ inElectricity inGrow ) ) )

    (gimp-image-resize img imgWidth imgHeight 0 0)
    (gimp-layer-resize theLayer imgWidth imgHeight 0 0)
    (gimp-layer-resize theTextLayer imgWidth imgHeight 0 0)

    (gimp-layer-set-offsets  theText theBufferX theBufferY )
    (gimp-floating-sel-anchor theText)

    (set! theTextLayer2 (car (gimp-layer-copy theTextLayer TRUE)))
    (gimp-image-add-layer img theTextLayer2 1)

    (plug-in-gauss-iir 1 img theTextLayer2 16 TRUE TRUE)
    (plug-in-bump-map 1 img theTextLayer theTextLayer2 135.0 45.0 32 0 0 0 0 TRUE FALSE 0)

    (gimp-selection-layer-alpha theTextLayer)

    (gimp-selection-grow img 2)
    (gimp-selection-feather img 8)
		
		(gimp-palette-set-foreground '(255 255 255))
		(gimp-edit-fill theTextLayer2 FG-IMAGE-FILL)
		(gimp-selection-none img)

		(script-fu-duplicate-layer-electricity-anim img theTextLayer)
		(set! duplicate (car(gimp-image-get-active-layer img)))
		(gimp-drawable-set-visible duplicate FALSE)

		(gimp-edit-copy-visible img)
				
		(script-fu-electricity-alphas img duplicate inGrow inElectricity inIceColor)

		(if (not (= framenum 1))
 		(gimp-image-merge-visible-layers img 0) () )

		(while (> (- framenum 1) 0)
		(begin
			(set! animation (car(gimp-edit-paste duplicate FALSE)))
			(set! animation (car(gimp-floating-sel-to-layer animation)))
			(script-fu-electricity-alphas img duplicate inGrow inElectricity inIceColor)
			(set! animation (car(gimp-image-get-active-layer img)))
			(gimp-image-merge-down img animation 0)
			(set! framenum (- framenum 1))
		) )

		(gimp-image-remove-layer img duplicate)
				
	(if (= framenum_source 1)
	(begin
		(if (= inFlatten TRUE)
      		(gimp-image-flatten img) ()  )	
	) )
			
    (gimp-palette-set-background old-bg)
    (gimp-palette-set-foreground old-fg)

    (gimp-display-new img)
    (list  img theLayer theText)

    ; Bereinigen Dirty-Flag
    ;(gimp-image-clean-all img)

  )
)

(script-fu-register
  "script-fu-electricity-logos-animated"
  "<Toolbox>/Xtns/Logos (MS)/Electricity (With Animation Option)..."
  "Creates an animated electricity logo based on the electricity logo script."
  "Michael Schalla"
  "Michael Schalla"
  "October 2002"
  ""
  SF-ADJUSTMENT "How Many Frames? (Use this to make an Animation)"      '(1 1 50 1 10 0 1)
  SF-STRING "Text"               "electricity"
  SF-FONT   "Font"               "-*-Arial Black-*-r-*-*-24-*-*-*-p-*-*-*"
  SF-ADJUSTMENT "Font Size"      '(200 2 1000 1 10 0 1)
  SF-COLOR  "Electricity Color"  '(32 128 255)
  SF-COLOR  "Text Color"         '(192 64 64)
  SF-ADJUSTMENT "Grow"					 '(-6 -50 50 1 1 0 1)
  SF-ADJUSTMENT "Electricity" 	 '(16 2 100 1 1 0 1)
  SF-TOGGLE "Absolute Size?"     FALSE
  SF-VALUE  "Image Width"        "400"
  SF-VALUE  "Image Height"       "150"
  SF-TOGGLE "Flatten Image? (Only used when there is 1 Frame)"     FALSE
)